--[[
    FiveM Scripts
    Copyright C 2018  Sighmir

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    at your option any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
]]


vRP = Proxy.getInterface("vRP")
vRPg = Proxy.getInterface("vRP_garages")

function deleteVehiclePedIsIn()
  local v = GetVehiclePedIsIn(GetPlayerPed(-1),false)
  SetVehicleHasBeenOwnedByPlayer(v,false)
  Citizen.InvokeNative(0xAD738C3085FE7E11, v, false, true) -- set not as mission entity
  SetVehicleAsNoLongerNeeded(Citizen.PointerValueIntInitialized(v))
  Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(v))
end

local vehshop = {
	opened = false,
	title = "Vehicle Shop",
	currentmenu = "main",
	lastmenu = nil,
	currentpos = nil,
	selectedbutton = 0,
	marker = { r = 0, g = 155, b = 255, a = 200, type = 1 },
	menu = {
		x = 0.1,
		y = 0.08,
		width = 0.2,
		height = 0.04,
		buttons = 10,
		from = 1,
		to = 10,
		scale = 0.4,
		font = 0,
		["main"] = {
			title = "Agencia de Carros",
			name = "main",
			buttons = {
				{name = "Carros", description = ""},
				{name = "Motocicletas", description = ""},
			}
		},
		["Carros"] = {
			title = "Carros",
			name = "Carros",
			buttons = {
				{name = "Deportivos", description = ''},
				{name = "Camionetas", description = ''},
				{name = "SUV", description = ''},
				{name = "LowRider", description = ''},
				{name = "Sedan", description = ''},
				{name = "Donacion", description = ''},
				{name = "VIP", description = ''},
				--{name = "cycles", description = ''},
			}
		},
		["Deportivos"] = {
			title = "Deportivos",
			name = "Deportivos",
			buttons = {
				{name = "Nissan GTR", costs = 1500000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "gtr"},
				{name = "Honda Civic TypeR", costs = 350000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "hondacivictr"},
				{name = "Mustang GT 2019", costs = 800000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "mustang19"},
				{name = "McLaren Senna", costs = 2300000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "senna"},
				{name = "Audi A5", costs = 650000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "sentinel"},
				{name = "Viper SRT", costs = 1250000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "viper"},
				{name = "Ford Focus RS", costs = 600000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "focusrs"},
				{name = "Volkswagen Golf", costs = 550000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "mk7pandem"},

			}
		},
		["Camionetas"] = {
			title = "Camionetas",
			name = "Camionetas",
			buttons = {
				{name = "Range Rover", costs = 1500000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "18Velar"},
				{name = "BMW X5", costs = 650000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "x5bmw"},
				{name = "GMC Yukon", costs = 1000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "gmcyd"},
				{name = "Silverado", costs = 600000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "20trailboss"},
				{name = "Suburban", costs = 1000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "subn"},
			}
		},
		["LowRider"] = {
			title = "LowRider",
			name = "LowRider",
			buttons = {
				{name = "Chevrolet Impala", costs = 700000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "impalass"},
			}
		},
		["Sedan"] = {
			title = "Sedan",
			name = "Sedan",
			buttons = {
				{name = "Audi RS6", costs = 600000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "rs6"},
				{name = "Toyota Prius", costs = 50000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "prius"},
				{name = "BMW M3", costs = 550000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "m3f80"},
				{name = "Volkswagen Vocho", costs = 300000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "fusca"},
				{name = "Camry XSE 2018", costs = 500000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "camry18"},
				{name = "Subaru Impreza", costs = 450000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "ySbrImpS11"},
			}
		},
		["Donacion"] = {
			title = "Donacion",
			name = "Donacion",
			buttons = {
				{name = "AMG G65", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "g65amg"},
				{name = "Challenger Demon", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "demon"},
				{name = "Lamborghini Aventador", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "aventadors"},
				{name = "Suburban (Policias)", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "sspres"},
				{name = "Porsche 911", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "str20"},
				{name = "AMG GT", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "amggtsprior"},
				{name = "Toyota Supra", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "supraa90"},
				{name = "Tesla M3", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "tmodel"},
				{name = "Ford F350 Super Duty", costs = 100000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "18f350"},
			}
		},
		["VIP"] = {
			title = "VIP",
			name = "VIP",
			buttons = {
			
			}
		},
		["SUV"] = {
			title = "SUV",
			name = "SUV",
			buttons = {
				{name = "Lamborghini Urus", costs = 2000000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "urus2018"},
				{name = "Porsche Cayenne", costs = 1400000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "cayenne"},
				{name = "Land Cruiser", costs = 1200000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "vxr"},
				{name = "Lexus RX 450H", costs = 1350000, speed = 100, acce = 100, brake = 100, trac = 100, description = {}, model = "rx450h"},
			}
		},
		["Motocicletas"] = {
			title = "Motocicletas",
			name = "Motocicletas",
			buttons = {
				{name = "Akuma", costs = 9000, description = {}, model = "AKUMA"},
				{name = "Bagger", costs = 5000, description = {}, model = "bagger"},
				{name = "Bati 801", costs = 15000, description = {}, model = "bati"},
				{name = "Bati 801RR", costs = 15000, description = {}, model = "bati2"},
				{name = "BF400", costs = 95000, description = {}, model = "bf400"},
				{name = "Carbon RS", costs = 40000, description = {}, model = "carbonrs"},
				{name = "Cliffhanger", costs = 225000, description = {}, model = "cliffhanger"},
				{name = "Daemon", costs = 5000, description = {}, model = "daemon"},
				{name = "Double T", costs = 12000, description = {}, model = "double"},
				{name = "Enduro", costs = 48000, description = {}, model = "enduro"},
				{name = "Faggio", costs = 4000, description = {}, model = "faggio2"},
				{name = "Gargoyle", costs = 120000, description = {}, model = "gargoyle"},
				{name = "Hakuchou", costs = 82000, description = {}, model = "hakuchou"},
				{name = "Hexer", costs = 15000, description = {}, model = "hexer"},
				{name = "Innovation", costs = 90000, description = {}, model = "innovation"},
				{name = "Lectro", costs = 700000, description = {}, model = "lectro"},
				{name = "Nemesis", costs = 12000, description = {}, model = "nemesis"},
				{name = "PCJ-600", costs = 9000, description = {}, model = "pcj"},
				{name = "Ruffian", costs = 9000, description = {}, model = "ruffian"},
				{name = "Sanchez", costs = 7000, description = {}, model = "sanchez"},
				{name = "Sovereign", costs = 90000, description = {}, model = "sovereign"},
				{name = "Thrust", costs = 75000, description = {}, model = "thrust"},
				{name = "Vader", costs = 9000, description = {}, model = "vader"},
				{name = "Vindicator", costs = 600000, description = {}, model = "vindicator"},
			}
		},
	}
}
local fakecar = {model = '', car = nil}
local vehshop_locations = {
{entering = {-911.44,-227.45,39.91}, inside = {-901.05,-229.38,39.95,151.28}, outside = {-904.38,-243.32,39.85,155.9}},
}

local vehshop_blips ={}
local inrangeofvehshop = false
local currentlocation = nil
local boughtcar = false

function vehSR_drawTxt(text,font,centre,x,y,scale,r,g,b,a)
	SetTextFont(font)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextColour(r, g, b, a)
	SetTextDropShadow(0, 0, 0, 0,255)
	SetTextEdge(1, 0, 0, 0, 255)
	SetTextDropShadow()
	SetTextOutline()
	SetTextCentre(centre)
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawText(x , y)
end

function vehSR_IsPlayerInRangeOfVehshop()
	return inrangeofvehshop
end

local firstspawn = 0
AddEventHandler('playerSpawned', function(spawn)
if firstspawn == 0 then
	--326 car blip 227 225
	vehSR_ShowVehshopBlips(true)
	firstspawn = 1
end
end)

function vehSR_ShowVehshopBlips(bool)
	if bool and #vehshop_blips == 0 then
		for station,pos in pairs(vehshop_locations) do
			local loc = pos
			pos = pos.entering
			local blip = AddBlipForCoord(pos[1],pos[2],pos[3])
			-- 60 58 137
			SetBlipSprite(blip,326)
			BeginTextCommandSetBlipName("STRING")
			AddTextComponentString("Simeon Showroom")
			EndTextCommandSetBlipName(blip)
			SetBlipAsShortRange(blip,true)
			SetBlipAsMissionCreatorBlip(blip,true)
			table.insert(vehshop_blips, {blip = blip, pos = loc})
		end
		Citizen.CreateThread(function()
			while #vehshop_blips > 0 do
				Citizen.Wait(0)
				local inrange = false
				for i,b in ipairs(vehshop_blips) do
					if IsPlayerWantedLevelGreater(GetPlayerIndex(),0) == false and vehshop.opened == false and IsPedInAnyVehicle(vehSR_LocalPed(), true) == false and  GetDistanceBetweenCoords(b.pos.entering[1],b.pos.entering[2],b.pos.entering[3],GetEntityCoords(vehSR_LocalPed())) < 5 then
						DrawMarker(1,b.pos.entering[1],b.pos.entering[2],b.pos.entering[3],0,0,0,0,0,0,2.001,2.0001,0.5001,0,155,255,200,0,0,0,0)
						vehSR_drawTxt("Presiona ~g~ENTER~s~ para comprar un ~b~vehiculo",0,1,0.5,0.8,0.6,255,255,255,255)
						currentlocation = b
						inrange = true
					end
				end
				inrangeofvehshop = inrange
			end
		end)
	elseif bool == false and #vehshop_blips > 0 then
		for i,b in ipairs(vehshop_blips) do
			if DoesBlipExist(b.blip) then
				SetBlipAsMissionCreatorBlip(b.blip,false)
				Citizen.InvokeNative(0x86A652570E5F25DD, Citizen.PointerValueIntInitialized(b.blip))
			end
		end
		vehshop_blips = {}
	end
end

function vehSR_f(n)
	return n + 0.0001
end

function vehSR_LocalPed()
	return GetPlayerPed(-1)
end

function vehSR_try(f, catch_f)
	local status, exception = pcall(f)
	if not status then
		catch_f(exception)
	end
end
function vehSR_firstToUpper(str)
    return (str:gsub("^%l", string.upper))
end
--local veh = nil
function vehSR_OpenCreator()
	boughtcar = false
	local ped = vehSR_LocalPed()
	local pos = currentlocation.pos.inside
	FreezeEntityPosition(ped,true)
	SetEntityVisible(ped,false)
	local g = Citizen.InvokeNative(0xC906A7DAB05C8D2B,pos[1],pos[2],pos[3],Citizen.PointerValueFloat(),0)
	SetEntityCoords(ped,pos[1],pos[2],g)
	SetEntityHeading(ped,pos[4])
	vehshop.currentmenu = "main"
	vehshop.opened = true
	vehshop.selectedbutton = 0
end
local vehicle_price = 0
function vehSR_CloseCreator(vehicle,veh_type)
	Citizen.CreateThread(function()
		local ped = vehSR_LocalPed()
		if not boughtcar then
			local pos = currentlocation.pos.entering
			SetEntityCoords(ped,pos[1],pos[2],pos[3])
			FreezeEntityPosition(ped,false)
			SetEntityVisible(ped,true)
		else
			deleteVehiclePedIsIn()
			vRP.teleport({-44.21378326416,-1079.1402587891,26.67050743103})
			vRPg.spawnBoughtVehicle({veh_type, vehicle})
			SetEntityVisible(ped,true)
			FreezeEntityPosition(ped,false)
		end
		vehshop.opened = false
		vehshop.menu.from = 1
		vehshop.menu.to = 10
	end)
end

function vehSR_drawMenuButton(button,x,y,selected)
	local menu = vehshop.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(menu.scale, menu.scale)
	if selected then
		SetTextColour(0, 0, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(button.name)
	if selected then
		DrawRect(x,y,menu.width,menu.height,255,255,255,255)
	else
		DrawRect(x,y,menu.width,menu.height,0,0,0,150)
	end
	DrawText(x - menu.width/2 + 0.005, y - menu.height/2 + 0.0028)
end

function vehSR_drawMenuTitle(txt,x,y)
local menu = vehshop.menu
	SetTextFont(2)
	SetTextProportional(0)
	SetTextScale(0.5, 0.5)
	SetTextColour(255, 255, 255, 255)
	SetTextEntry("STRING")
	AddTextComponentString(txt)
	DrawRect(x,y,menu.width,menu.height,0,0,0,150)
	DrawText(x - menu.width/2 + 0.005, y - menu.height/2 + 0.0028)
end
function vehSR_tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end
function vehSR_Notify(text)
SetNotificationTextEntry('STRING')
AddTextComponentString(text)
DrawNotification(false, false)
end

function vehSR_drawMenuRight(txt,x,y,selected)
	local menu = vehshop.menu
	SetTextFont(menu.font)
	SetTextProportional(0)
	SetTextScale(menu.scale, menu.scale)
	if selected then
		SetTextColour(0, 0, 0, 255)
	else
		SetTextColour(255, 255, 255, 255)
	end
	SetTextCentre(0)
	SetTextEntry("STRING")
	AddTextComponentString(txt)
	DrawText(x + menu.width/2 - 0.06, y - menu.height/2 + 0.0028)
end
local backlock = false
Citizen.CreateThread(function()
	local last_dir
	while true do
		Citizen.Wait(0)
		if IsControlJustPressed(1,201) and vehSR_IsPlayerInRangeOfVehshop() then
			if vehshop.opened then
				vehSR_CloseCreator("","")
			else
				vehSR_OpenCreator()
			end
		end
		if vehshop.opened then
			local ped = vehSR_LocalPed()
			local menu = vehshop.menu[vehshop.currentmenu]
			vehSR_drawTxt(vehshop.title,1,1,vehshop.menu.x,vehshop.menu.y,1.0, 255,255,255,255)
			vehSR_drawMenuTitle(menu.title, vehshop.menu.x,vehshop.menu.y + 0.08)
			vehSR_drawTxt(vehshop.selectedbutton.."/"..vehSR_tablelength(menu.buttons),0,0,vehshop.menu.x + vehshop.menu.width/2 - 0.0385,vehshop.menu.y + 0.067,0.4, 255,255,255,255)
			local y = vehshop.menu.y + 0.12
			buttoncount = vehSR_tablelength(menu.buttons)
			local selected = false

			for i,button in pairs(menu.buttons) do
				if i >= vehshop.menu.from and i <= vehshop.menu.to then

					if i == vehshop.selectedbutton then
						selected = true
					else
						selected = false
					end
					vehSR_drawMenuButton(button,vehshop.menu.x,y,selected)
					if button.costs ~= nil then
						if vehshop.currentmenu == "Deportivos" or vehshop.currentmenu == "Camionetas" or vehshop.currentmenu == "SUV" or vehshop.currentmenu == "LowRider" or vehshop.currentmenu == "Sedan" or vehshop.currentmenu == "Donacion" or vehshop.currentmenu == "VIP" or vehshop.currentmenu == "vans" or vehshop.currentmenu == "industrial" or vehshop.currentmenu == "cycles" or vehshop.currentmenu == "Motocicletas" then
							vehSR_drawMenuRight(button.costs.."$",vehshop.menu.x,y,selected)
						else
							vehSR_drawMenuButton(button,vehshop.menu.x,y,selected)
						end
					end
					y = y + 0.04
					if vehshop.currentmenu == "Deportivos" or vehshop.currentmenu == "Camionetas" or vehshop.currentmenu == "SUV" or vehshop.currentmenu == "LowRider" or vehshop.currentmenu == "Sedan" or vehshop.currentmenu == "Donacion" or vehshop.currentmenu == "VIP" or vehshop.currentmenu == "vans" or vehshop.currentmenu == "industrial" or vehshop.currentmenu == "cycles" or vehshop.currentmenu == "Motocicletas" then
						if selected then
							if fakecar.model ~= button.model then
								if DoesEntityExist(fakecar.car) then
									Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(fakecar.car))
								end
								local pos = currentlocation.pos.inside
								local hash = GetHashKey(button.model)
								RequestModel(hash)
								local timer = 0
								while not HasModelLoaded(hash) and timer < 255 do
									Citizen.Wait(1)
									vehSR_drawTxt("Loading...",0,1,0.5,0.5,1.5,255,255-timer,255-timer,255)
									RequestModel(hash)
									timer = timer + 1
								end
								if timer < 255 then
									local veh = CreateVehicle(hash,pos[1],pos[2],pos[3],pos[4],false,false)
									while not DoesEntityExist(veh) do
										Citizen.Wait(1)
										vehSR_drawTxt("Loading...",0,1,0.5,0.5,1.5,255,255-timer,255-timer,255)
									end
									FreezeEntityPosition(veh,true)
									SetEntityInvincible(veh,true)
									SetVehicleDoorsLocked(veh,4)
									--SetEntityCollision(veh,false,false)
									TaskWarpPedIntoVehicle(vehSR_LocalPed(),veh,-1)
									for i = 0,24 do
										SetVehicleModKit(veh,0)
										RemoveVehicleMod(veh,i)
									end
									fakecar = { model = button.model, car = veh}
								else
									timer = 0
									while timer < 50 do
										Citizen.Wait(1)
										vehSR_drawTxt("Failed!",0,1,0.5,0.5,1.5,255,0,0,255)
										timer = timer + 1
									end
									if last_dir then
										if vehshop.selectedbutton < buttoncount then
											vehshop.selectedbutton = vehshop.selectedbutton +1
											if buttoncount > 10 and vehshop.selectedbutton > vehshop.menu.to then
												vehshop.menu.to = vehshop.menu.to + 1
												vehshop.menu.from = vehshop.menu.from + 1
											end
										else
											last_dir = false
											vehshop.selectedbutton = vehshop.selectedbutton -1
											if buttoncount > 10 and vehshop.selectedbutton < vehshop.menu.from then
												vehshop.menu.from = vehshop.menu.from -1
												vehshop.menu.to = vehshop.menu.to - 1
											end
										end
									else
										if vehshop.selectedbutton > 1 then
											vehshop.selectedbutton = vehshop.selectedbutton -1
											if buttoncount > 10 and vehshop.selectedbutton < vehshop.menu.from then
												vehshop.menu.from = vehshop.menu.from -1
												vehshop.menu.to = vehshop.menu.to - 1
											end
										else
											last_dir = true
											vehshop.selectedbutton = vehshop.selectedbutton +1
											if buttoncount > 10 and vehshop.selectedbutton > vehshop.menu.to then
												vehshop.menu.to = vehshop.menu.to + 1
												vehshop.menu.from = vehshop.menu.from + 1
											end
										end
									end
								end
							end
						end
					end
					if selected and IsControlJustPressed(1,201) then
						vehSR_ButtonSelected(button)
					end
				end
			end
			if IsControlJustPressed(1,202) then
				vehSR_Back()
			end
			if IsControlJustReleased(1,202) then
				backlock = false
			end
			if IsControlJustPressed(1,188) then
				last_dir = false
				if vehshop.selectedbutton > 1 then
					vehshop.selectedbutton = vehshop.selectedbutton -1
					if buttoncount > 10 and vehshop.selectedbutton < vehshop.menu.from then
						vehshop.menu.from = vehshop.menu.from -1
						vehshop.menu.to = vehshop.menu.to - 1
					end
				end
			end
			if IsControlJustPressed(1,187)then
				last_dir = true
				if vehshop.selectedbutton < buttoncount then
					vehshop.selectedbutton = vehshop.selectedbutton +1
					if buttoncount > 10 and vehshop.selectedbutton > vehshop.menu.to then
						vehshop.menu.to = vehshop.menu.to + 1
						vehshop.menu.from = vehshop.menu.from + 1
					end
				end
			end
		end

	end
end)


function vehSR_ButtonSelected(button)
	local ped = GetPlayerPed(-1)
	local this = vehshop.currentmenu
	local btn = button.name
	if this == "main" then
		if btn == "Carros" then
			vehSR_OpenMenu('Carros')
		elseif btn == "Motocicletas" then
			vehSR_OpenMenu('Motocicletas')
		end
	elseif this == "Carros" then
		if btn == "LowRider" then
			vehSR_OpenMenu('LowRider')
		elseif btn == "SUV" then
			vehSR_OpenMenu('SUV')
		elseif btn == "Deportivos" then
			vehSR_OpenMenu('Deportivos')
		elseif btn == "Camionetas" then
			vehSR_OpenMenu('Camionetas')
		elseif btn == "Sedan" then
			vehSR_OpenMenu("Sedan")
		elseif btn == "Donacion" then
			vehSR_OpenMenu('Donacion')
		elseif btn == "VIP" then
			vehSR_OpenMenu('VIP')
		elseif btn == "vans" then
			vehSR_OpenMenu('vans')
		end
	elseif this == "Deportivos" or this == "Camionetas" or this == "SUV" or this == "LowRider" or this == "Sedan" or this == "Donacion" or this == "VIP" or this == "vans" or this == "industrial" then
		TriggerServerEvent('veh_SR:CheckMoneyForVeh',button.model,button.costs, "car")
    elseif this == "cycles" or this == "Motocicletas" then
		TriggerServerEvent('veh_SR:CheckMoneyForVeh',button.model,button.costs, "bike")
	end
end

RegisterNetEvent('veh_SR:CloseMenu')
AddEventHandler('veh_SR:CloseMenu', function(vehicle, veh_type)
	boughtcar = true
	vehSR_CloseCreator(vehicle,veh_type)
end)

function vehSR_OpenMenu(menu)
	fakecar = {model = '', car = nil}
	vehshop.lastmenu = vehshop.currentmenu
	if menu == "Carros" then
		vehshop.lastmenu = "main"
	elseif menu == "bikes"  then
		vehshop.lastmenu = "main"
	elseif menu == 'race_create_objects' then
		vehshop.lastmenu = "main"
	elseif menu == "race_create_objects_spawn" then
		vehshop.lastmenu = "race_create_objects"
	end
	vehshop.menu.from = 1
	vehshop.menu.to = 10
	vehshop.selectedbutton = 0
	vehshop.currentmenu = menu
end


function vehSR_Back()
	if backlock then
		return
	end
	backlock = true
	if vehshop.currentmenu == "main" then
		vehSR_CloseCreator("","")
	elseif vehshop.currentmenu == "Deportivos" or vehshop.currentmenu == "Camionetas" or vehshop.currentmenu == "SUV" or vehshop.currentmenu == "LowRider" or vehshop.currentmenu == "Sedan" or vehshop.currentmenu == "Donacion" or vehshop.currentmenu == "VIP" or vehshop.currentmenu == "vans" or vehshop.currentmenu == "industrial" or vehshop.currentmenu == "cycles" or vehshop.currentmenu == "Motocicletas" then
		if DoesEntityExist(fakecar.car) then
			Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(fakecar.car))
		end
		fakecar = {model = '', car = nil}
		vehSR_OpenMenu(vehshop.lastmenu)
	else
		vehSR_OpenMenu(vehshop.lastmenu)
	end

end

function vehSR_stringstarts(String,Start)
   return string.sub(String,1,string.len(Start))==Start
end